SystemOrganization addCategory: #'ObjectRelational-Mock'!
SystemOrganization addCategory: #'ObjectRelational-Test'!
SystemOrganization addCategory: #'ObjectRelational-Accessor'!

MASelectorAccessorTest subclass: #ORToManyAccessorTest
	instanceVariableNames: 'target'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjectRelational-Test'!

!ORToManyAccessorTest methodsFor: 'private' stamp: 'pmm 10/24/2006 21:24'!
accessorInstance
	^ (self actualClass selector: #companies)
		referencedClass: ORMockCompany;
		foreignKey: #containerid;
		yourself! !

!ORToManyAccessorTest methodsFor: 'private' stamp: 'pmm 10/24/2006 21:12'!
actualClass
	^ORToManyAccessor! !

!ORToManyAccessorTest methodsFor: 'running' stamp: 'pmm 10/24/2006 21:08'!
setUp
	super setUp.
	target := ORMockCompanyContainer new! !

!ORToManyAccessorTest methodsFor: 'accessing' stamp: 'pmm 10/24/2006 21:07'!
target
	^ target! !

!ORToManyAccessorTest methodsFor: 'testing' stamp: 'pmm 10/24/2006 21:42'!
testRead
	| companies |
	companies := Array
		with: ORMockCompany new
		with: ORMockCompany new.
	ORMockCompany companies: companies.
	
	self assert: target companies isNil.
	self assert: (self accessor read: self target) = companies.

	companies := Array
		with: ORMockCompany new.
	ORMockCompany companies: companies.
		
	self target companies: companies.
	self assert: (self accessor read: self target) = companies! !

!ORToManyAccessorTest methodsFor: 'testing' stamp: 'pmm 10/24/2006 21:32'!
testReadSelector
	self accessor readSelector: #contents.

	self assert: self accessor selector = #contents.
	self assert: self accessor readSelector = #contents.
	self assert: self accessor writeSelector = #companies:! !

!ORToManyAccessorTest methodsFor: 'testing' stamp: 'pmm 10/24/2006 21:23'!
testWrite
	| companies |
	companies := Array with: (ORMockCompany new).
	self accessor write: companies to: self target.
	self assert: self target companies = companies.! !

!ORToManyAccessorTest methodsFor: 'testing' stamp: 'pmm 10/24/2006 21:24'!
testWriteSelector
	self accessor writeSelector: #contents:.

	self assert: self accessor selector = #companies.
	self assert: self accessor readSelector = #companies.
	self assert: self accessor writeSelector = #contents:! !

MASelectorAccessorTest subclass: #ORToOneAccessorTest
	instanceVariableNames: 'target'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjectRelational-Test'!

!ORToOneAccessorTest methodsFor: 'private' stamp: 'pmm 10/24/2006 21:13'!
accessorInstance
	^ (self actualClass selector: #container)
		referencedClass: ORMockCompanyContainer;
		yourself! !

!ORToOneAccessorTest methodsFor: 'private' stamp: 'pmm 10/24/2006 21:12'!
actualClass
	^ORToOneAccessor! !

!ORToOneAccessorTest methodsFor: 'running' stamp: 'pmm 10/24/2006 21:27'!
setUp
	super setUp.
	target := ORMockCompany new! !

!ORToOneAccessorTest methodsFor: 'accessing' stamp: 'pmm 10/24/2006 21:07'!
target
	^ target! !

!ORToOneAccessorTest methodsFor: 'testing' stamp: 'pmm 10/24/2006 21:18'!
testIdReadSelector
	self accessor selector: #contents.

	self assert: self accessor selector = #contents.
	self assert: self accessor readSelector = #contents.
	self assert: self accessor idReadSelector = #contentsId.! !

!ORToOneAccessorTest methodsFor: 'testing' stamp: 'pmm 10/24/2006 21:19'!
testIdWriteSelector
	self accessor selector: #contents.

	self assert: self accessor selector = #contents.
	self assert: self accessor writeSelector = #contents:.
	self assert: self accessor idWriteSelector = #contentsId:.! !

!ORToOneAccessorTest methodsFor: 'testing' stamp: 'pmm 10/24/2006 21:50'!
testRead
	| container |
	self target containerId: 42.
		
	container := ORMockCompanyContainer new
		id: 42;
		yourself.
		
	ORMockCompanyContainer container: container.
		
	self target container isNil.
	self assert: (self accessor read: self target) = container.

	self target container: nil.
	self target containerId: nil.
	
	self assert: (self accessor read: self target) isNil! !

!ORToOneAccessorTest methodsFor: 'testing' stamp: 'pmm 10/24/2006 21:32'!
testReadSelector
	self accessor readSelector: #contents.

	self assert: self accessor selector = #contents.
	self assert: self accessor readSelector = #contents.
	self assert: self accessor writeSelector = #container:! !

!ORToOneAccessorTest methodsFor: 'testing' stamp: 'pmm 10/24/2006 21:53'!
testWrite
	| container |
	container := ORMockCompanyContainer new
		id: 42;
		yourself.
	
	self assert: self target containerId isNil.
	self assert: self target container isNil.
	
	self accessor write: container to: self target.
	self assert: self target container = container.
	self assert: self target containerId = 42.
		
	self accessor write: nil to: self target.

	self assert: self target containerId isNil.
	self assert: self target container isNil.! !

!ORToOneAccessorTest methodsFor: 'testing' stamp: 'pmm 10/24/2006 21:34'!
testWriteSelector
	self accessor writeSelector: #contents:.

	self assert: self accessor selector = #container.
	self assert: self accessor readSelector = #container.
	self assert: self accessor writeSelector = #contents:! !

MASelectorAccessor subclass: #ORToManyAccessor
	instanceVariableNames: 'referencedClass foreignKey'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjectRelational-Accessor'!

!ORToManyAccessor methodsFor: 'comparing' stamp: 'pmm 10/24/2006 19:46'!
= anObject
	^super = anObject
		and: [ self foreignKey = anObject foreignKey ]
		and: [ self referencedClass name = anObject referencedClass name ]! !

!ORToManyAccessor methodsFor: 'testing' stamp: 'pmm 10/24/2006 19:46'!
canRead: aModel
	^(super canRead: aModel)
		and: [ self foreignKey notNil ]
		and: [ self referencedClass notNil ]! !

!ORToManyAccessor methodsFor: 'accessing' stamp: 'pmm 10/24/2006 19:44'!
foreignKey
	^foreignKey! !

!ORToManyAccessor methodsFor: 'accessing' stamp: 'pmm 10/24/2006 19:45'!
foreignKey: aClass 
	foreignKey := aClass! !

!ORToManyAccessor methodsFor: 'comparing' stamp: 'pmm 10/24/2006 19:47'!
hash
	^ (super hash
		bitXor: self foreignKey hash)
		bitXor: self referencedClass name hash! !

!ORToManyAccessor methodsFor: 'model' stamp: 'pmm 10/24/2006 19:50'!
read: aModel
	| values |
	values := super read: aModel.
	values isNil ifTrue: [
		values := self referencedClass
			loadWhere: self foreignKey equals: aModel id.
		aModel perform: self writeSelector with: values ].
	^values! !

!ORToManyAccessor methodsFor: 'accessing' stamp: 'pmm 10/24/2006 19:44'!
referencedClass
	^referencedClass! !

!ORToManyAccessor methodsFor: 'accessing' stamp: 'pmm 10/24/2006 19:45'!
referencedClass: aClass 
	referencedClass := aClass! !

!ORToManyAccessor methodsFor: 'printing' stamp: 'pmm 10/24/2006 19:57'!
storeOn: aStream
	aStream nextPut: $(.
	super storeOn: aStream.
	aStream nextPutAll: ' foreignKey: '.
	aStream store: self foreignKey.
	aStream nextPutAll: '; referencedClass: '.
	aStream nextPutAll:  self referencedClass name.
	aStream nextPutAll: '; yourself'.
	aStream nextPut: $)! !

MASelectorAccessor subclass: #ORToOneAccessor
	instanceVariableNames: 'referencedClass idReadSelector idWriteSelector'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjectRelational-Accessor'!

!ORToOneAccessor methodsFor: 'comparing' stamp: 'pmm 10/24/2006 19:47'!
= anObject
	^ super = anObject
		and: [ self referencedClass name = anObject referencedClass name ]! !

!ORToOneAccessor methodsFor: 'testing' stamp: 'pmm 10/24/2006 19:14'!
canRead: aModel
	^(super canRead: aModel)
		and: [ self idReadSelector notNil ]
		and: [ aModel respondsTo: self idReadSelector ]
		and: [ self referencedClass notNil ]! !

!ORToOneAccessor methodsFor: 'testing' stamp: 'pmm 10/24/2006 19:14'!
canWrite: aModel
	^(super canRead: aModel)
		and: [ self idWriteSelector notNil ]
		and: [ aModel respondsTo: self idWriteSelector ]! !

!ORToOneAccessor methodsFor: 'comparing' stamp: 'pmm 10/24/2006 19:47'!
hash
	^ super hash
		bitXor: self referencedClass name hash! !

!ORToOneAccessor methodsFor: 'accessing' stamp: 'pmm 10/24/2006 19:10'!
idReadSelector
	^idReadSelector! !

!ORToOneAccessor methodsFor: 'accessing' stamp: 'pmm 10/24/2006 19:44'!
idReadSelector: aSymbol 
	idReadSelector := aSymbol! !

!ORToOneAccessor methodsFor: 'accessing' stamp: 'pmm 10/24/2006 19:10'!
idWriteSelector
	^idWriteSelector! !

!ORToOneAccessor methodsFor: 'accessing' stamp: 'pmm 10/24/2006 19:44'!
idWriteSelector: aSymbol 
	idWriteSelector := aSymbol! !

!ORToOneAccessor methodsFor: 'model' stamp: 'pmm 10/24/2006 19:20'!
read: aModel
	| value id |
	value := super read: aModel.
	value isNil ifTrue: [
		id := aModel perform: self idReadSelector.
		id isNil ifFalse: [
			value := self referencedClass loadId: id.
			aModel perform: self writeSelector with: value ] ].
	^value! !

!ORToOneAccessor methodsFor: 'accessing' stamp: 'pmm 10/24/2006 21:43'!
readSelector: aSelector
	super readSelector: aSelector.
	self idReadSelector: (aSelector isNil ifFalse: [ (aSelector, #Id) asSymbol ])! !

!ORToOneAccessor methodsFor: 'accessing' stamp: 'pmm 10/24/2006 19:09'!
referencedClass
	^referencedClass! !

!ORToOneAccessor methodsFor: 'accessing' stamp: 'pmm 10/24/2006 19:12'!
referencedClass: aClass 
	referencedClass := aClass! !

!ORToOneAccessor methodsFor: 'printing' stamp: 'pmm 10/24/2006 19:56'!
storeOn: aStream
	aStream nextPut: $(.
	super storeOn: aStream.
	aStream nextPutAll: ' referencedClass: '.
	aStream nextPutAll:  self referencedClass name.
	aStream nextPutAll: '; yourself'.
	aStream nextPut: $)! !

!ORToOneAccessor methodsFor: 'model' stamp: 'pmm 10/24/2006 21:55'!
write: anObject to: aModel
	| id |
	super write: anObject to: aModel.
	id := anObject isNil ifFalse: [ anObject id ].
	aModel perform: self idWriteSelector with: id! !

!ORToOneAccessor methodsFor: 'accessing' stamp: 'pmm 10/24/2006 21:44'!
writeSelector: aSelector
	super writeSelector: aSelector.
	self idWriteSelector: (aSelector isNil ifFalse: [ (aSelector allButLast, #Id:) asSymbol ])! !

Object subclass: #ORMockCompany
	instanceVariableNames: 'id containerId container'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjectRelational-Mock'!

ORMockCompany class
	instanceVariableNames: 'companies'!

ORMockCompany class
	instanceVariableNames: 'companies'!

!ORMockCompany class methodsFor: 'accessing' stamp: 'pmm 10/24/2006 21:38'!
companies
	^companies! !

!ORMockCompany class methodsFor: 'accessing' stamp: 'pmm 10/24/2006 21:38'!
companies: aCollection
	companies := aCollection! !

!ORMockCompany class methodsFor: 'mock-loading' stamp: 'pmm 10/24/2006 21:38'!
loadWhere: aSymbol equals: anInteger
	aSymbol = #containerid
		ifFalse: [ self error: 'invalid key' ].
	^self companies! !

!ORMockCompany methodsFor: 'accessing' stamp: 'pmm 10/24/2006 21:28'!
container
	^container! !

!ORMockCompany methodsFor: 'accessing' stamp: 'pmm 10/24/2006 21:28'!
container: anObject
	container := anObject! !

!ORMockCompany methodsFor: 'accessing' stamp: 'pmm 10/24/2006 21:28'!
containerId
	^containerId! !

!ORMockCompany methodsFor: 'accessing' stamp: 'pmm 10/24/2006 21:28'!
containerId: anObject
	containerId := anObject! !

!ORMockCompany methodsFor: 'accessing' stamp: 'pmm 10/24/2006 21:51'!
id
	^id! !

!ORMockCompany methodsFor: 'accessing' stamp: 'pmm 10/24/2006 21:51'!
id: anObject
	id := anObject! !

Object subclass: #ORMockCompanyContainer
	instanceVariableNames: 'id company companyId companies'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjectRelational-Mock'!

ORMockCompanyContainer class
	instanceVariableNames: 'container'!

ORMockCompanyContainer class
	instanceVariableNames: 'container'!

!ORMockCompanyContainer class methodsFor: 'accessing' stamp: 'pmm 10/24/2006 21:45'!
container
	^container! !

!ORMockCompanyContainer class methodsFor: 'accessing' stamp: 'pmm 10/24/2006 21:46'!
container: anObject
	container := anObject! !

!ORMockCompanyContainer class methodsFor: 'mock-loading' stamp: 'pmm 10/24/2006 21:47'!
loadId: anInteger
	anInteger = self container id
		ifFalse: [ self error: 'invalid container id' ].
	^self container! !

!ORMockCompanyContainer methodsFor: 'accessing' stamp: 'pmm 10/24/2006 21:15'!
companies
	^companies! !

!ORMockCompanyContainer methodsFor: 'accessing' stamp: 'pmm 10/24/2006 21:15'!
companies: anObject
	companies := anObject! !

!ORMockCompanyContainer methodsFor: 'accessing' stamp: 'pmm 10/24/2006 21:41'!
id
	^id! !

!ORMockCompanyContainer methodsFor: 'accessing' stamp: 'pmm 10/24/2006 21:41'!
id: anObject
	id := anObject! !
